/*
 * JLockOnAcceleration.java
 *
 * Created on 22. Juli 2004, 08:36
 */

package JLockOn;

/**
 *
 * @author  www.Flike.de
 *   Copyright 2004 Tobias Flaig
 *   JLockOn is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.awt.*;

public class JLockOnAcceleration extends javax.swing.JFrame {
    
    double gforce=0.0;
    double gforce1radiant=-112.5;
    Graphics g ;
    Graphics2D g2;
    Image gforcepic;
    Image gforcearrow;
    private Image bufferImage;
    private Graphics bufferGraphics;
    JLockOn jlockon;
    
    /** Creates new form JLockOnAcceleration */
    public JLockOnAcceleration(JLockOn ajlockon) {
        jlockon=ajlockon;
        this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    }
    
    public void start(int x, int y){
        initComponents();
        this.setLocation(x,y);
        try{
            java.net.URL imageURL =getClass().getResource("gforce.gif");
            gforcepic=getToolkit().createImage((java.awt.image.ImageProducer) imageURL.getContent());//f:/tobias/JLockOn/JLockOn/
            imageURL =getClass().getResource("altarrow.gif");
            gforcearrow=getToolkit().createImage((java.awt.image.ImageProducer) imageURL.getContent());
            
        } catch (Exception e){
            System.out.println(e);
        }
        super.repaint();
    }
    
    public void newData(double g){
        gforce=g;      
        gforce1radiant=-112.5+(22.5*gforce);
//        System.out.println(velo+","+vsi1radiant);
        super.repaint();
    }
    
    public void update(Graphics g){
        paint(g);
    }
    public void paint(Graphics f){
        bufferImage=createImage(getSize().width,getSize().height);
        bufferGraphics=bufferImage.getGraphics();
        g = jPanel1.getGraphics();
        g.clipRect(0,0, 237,237);
        g2 = (Graphics2D)bufferGraphics; 

        bufferGraphics.drawImage(gforcepic,0,0,this);

        g2.translate(119,119);
        g2.rotate(Math.toRadians(gforce1radiant));
        g2.drawImage(gforcearrow,-119,-119,this);
        g.drawImage(bufferImage,0,0,this);

    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();

        setResizable(false);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                click(evt);
            }
        });

        jPanel1.setMinimumSize(new java.awt.Dimension(237, 237));
        jPanel1.setPreferredSize(new java.awt.Dimension(237, 237));
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void click(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_click
        jlockon.newacceleration(this.isUndecorated(),this.getX(),this.getY());
        this.dispose();
    }//GEN-LAST:event_click
    
    /** Exit the Application */    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
