/*
 * JLockOnAttitude.java
 *
 * Created on 15. Juli 2004, 16:51
 */

package JLockOn;

/**
 *
 * @author  www.Flike.de
 *   Copyright 2004 Tobias Flaig
 *   JLockOn is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.awt.*;

public class JLockOnAttitude extends javax.swing.JFrame {
    
    double pitch=0.0;
    double bank=0.0;
    Graphics g ;
    Graphics2D g2,g3;
    Image attitude;
    Image attitudescale;
    Image attitudebird;
    private Image bufferImage;
    private Graphics bufferGraphics;
    JLockOn jlockon;
    boolean rus=false;
    
    /** Creates new form JLockOnAttitude */
    public JLockOnAttitude(JLockOn ajlockon) {
        jlockon=ajlockon;
        this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    }
    
    public void setRus(boolean b){
        rus=b;
    }
    
    
    public void start(int x,int y){
        initComponents();
        this.setLocation(x,y);
        try{
            java.net.URL imageURL =getClass().getResource("attitude.gif");
            attitude=getToolkit().createImage((java.awt.image.ImageProducer) imageURL.getContent());//f:/tobias/JLockOn/JLockOn/
            imageURL =getClass().getResource("attitudescale.gif");
            attitudescale=getToolkit().createImage((java.awt.image.ImageProducer) imageURL.getContent());
            imageURL =getClass().getResource("attitudebird.gif");
            attitudebird=getToolkit().createImage((java.awt.image.ImageProducer) imageURL.getContent());
        
        } catch (Exception e){
            System.out.println(e);
        }
        super.repaint();
    }
    public void newData(double p, double b){
        if (rus){
            pitch=p*-2.6;
        } else {
            pitch=p*2.6;
        }
        bank=b;

        super.repaint();
    }
    
    public void update(Graphics g){
        paint(g);
    }
    public void paint(Graphics f){
        bufferImage=createImage(getSize().width,getSize().height);
        bufferGraphics=bufferImage.getGraphics();
        g = jPanel1.getGraphics();
        g.clipRect(0,0, 237,237);
        g2 = (Graphics2D)bufferGraphics;

        
        g2.translate(119,119);
        g2.rotate(Math.toRadians(-bank));
        g2.drawImage(attitudescale,-119,-355-(int)pitch,this);
        g2.rotate(Math.toRadians(bank));
        g2.translate(-119,-119);
        bufferGraphics.drawImage(attitude,0,0,this);
        bufferGraphics.drawImage(attitudebird,0,0,this);
        
//        g2.drawImage(mach,0,0,this);
//        g2.drawImage(speedarrow,0,0,this);
        g.drawImage(bufferImage,0,0,this);

    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();

        setResizable(false);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                click(evt);
            }
        });

        jPanel1.setMinimumSize(new java.awt.Dimension(237, 237));
        jPanel1.setPreferredSize(new java.awt.Dimension(237, 237));
        jPanel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                click(evt);
            }
        });

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void click(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_click
        jlockon.newattitude(this.isUndecorated(),this.getX(),this.getY());
        this.dispose();
    }//GEN-LAST:event_click
    
    /** Exit the Application */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
