/*
 * JLockOnListener.java
 *
 * Created on 27. Juni 2004, 20:07
 */

package JLockOn;

/**
 *
 * @author  www.Flike.de
 *   Copyright 2004 Tobias Flaig
 *   JLockOn is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.io.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.Socket;
import java.net.ServerSocket;

public class JLockOnListener extends Thread{
    
    JLockOn jlockon = null;
    boolean running = true;
    Socket sock=null;
    BufferedReader reader=null;
    private static final int LUA_PORT = 6666;
    ServerSocket socke;
    
    /** Creates a new instance of JLockOnListener */
    public JLockOnListener(JLockOn a_jlockon) {
        jlockon = a_jlockon;
        System.out.println("creating socket...");
        try{
            socke = new ServerSocket(LUA_PORT);
        } catch (Exception e) {
            System.out.println("Exception in main: " + e);
            System.exit(0);
        } 
        this.start();
    }
    
    public void StopListener(){
        try{
            sock.close();
        } catch (Exception e) {
            System.out.println("Exception in main: " + e);
        }
        this.run();
    }
    
    public void run() {
        String input;
        try {
            sock=socke.accept();
            System.out.println("socket created");
            reader = new BufferedReader(new InputStreamReader(sock.getInputStream()));
        } catch (Exception e) {
            System.out.println("Exception in main: " + e);
            System.exit(0);
        } 
        while (running==true) {
            try{
                input=reader.readLine();
                if (input!=null && !input.equals("quit")){
//                    System.out.println("Data from socket: " + input);
                    jlockon.height1=(int)Double.parseDouble(input.split(",")[0]);
                    jlockon.velo=Double.parseDouble(input.split(",")[1]);
                    System.out.println("Data from socket: " + input.split(",")[1]);
                    jlockon.speed=Double.parseDouble(input.split(",")[2]);
                    jlockon.pitch=Double.parseDouble(input.split(",")[3]);
                    jlockon.bank=Double.parseDouble(input.split(",")[4]);
                    jlockon.gforce=Double.parseDouble(input.split(",")[5]);
                    jlockon.newData();
                }
                if (input!=null && input.equals("quit")){
                    this.StopListener();                 
                }
            }   catch (Exception e) {
                System.out.println("Exception in main: " + e);
                System.exit(0);
            }   
        }
    }
    
    
}
