/*
 * JLockOnSpeed.java
 *
 * Created on 8. Juli 2004, 11:53
 */

package JLockOn;

/**
 *
 ** @author  www.Flike.de
 *   Copyright 2004 Tobias Flaig
 *   JLockOn is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.awt.*;

public class JLockOnSpeed extends javax.swing.JFrame {
    
    double speed=0.0;
    double speed1radiant=10.0;
    double speed2radiant=55.0;
    Graphics g ;
    Graphics2D g2,g3;
    Image speedpic;
    Image speedarrow;
    Image mach;
    private Image bufferImage;
    private Graphics bufferGraphics;
    JLockOn jlockon;
    boolean a10=false;
    
    /** Creates new form JLockOnSpeed */
    public JLockOnSpeed(JLockOn ajlockon) {
        jlockon=ajlockon;
        this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    }
    
    public void start(int x,int y){
        initComponents();
        this.setLocation(x,y);
        try{
            java.net.URL imageURL =getClass().getResource("speed.gif");
            speedpic=getToolkit().createImage((java.awt.image.ImageProducer) imageURL.getContent());//f:/tobias/JLockOn/JLockOn/
            imageURL =getClass().getResource("speedarrow.gif");
            speedarrow=getToolkit().createImage((java.awt.image.ImageProducer) imageURL.getContent());
            imageURL =getClass().getResource("mach.gif");
            mach=getToolkit().createImage((java.awt.image.ImageProducer) imageURL.getContent());
        
        } catch (Exception e){
            System.out.println(e);
        }
        super.repaint();
    }
    
    public void setA10(boolean b){
        a10=b;
    }
    
    public void newData(double s){
        if (a10){
            speed=s*0.75+49;
        } else {
            speed=s;
        }
        if (speed<50){
            speed1radiant=10.0;
        } else if (speed>50 && speed<=300){
            speed1radiant=10.0+(((speed-50)/100.0)*53.3);
        } else if(speed>300 && speed<=400){
            speed1radiant=143.25+(((speed-300)/100.0)*44);
        } else if(speed>400 && speed<=500){
            speed1radiant=187.25+(((speed-400)/100.0)*26.4);
        } else if(speed>500 && speed<=700){
            speed1radiant=213.65+(((speed-500)/200.0)*70.4);
        } else if(speed>700 && speed<=1000){
            speed1radiant=284.05+(((speed-700)/300.0)*68);
        } else if(speed>1000){
            speed1radiant=352.05;
        }
        if (speed<=661.5){
            speed2radiant=45+speed1radiant-(((speed-50)/661.5)*15.0);
        } else {
            speed2radiant=30+speed1radiant-(((speed-661.5)/661.5)*30.0);
        }

        if (speed2radiant>360){
            speed2radiant=speed2radiant-360;
        } else if(speed2radiant<0){
            speed2radiant=speed2radiant+360;
        }
        super.repaint();
    }
    
    public void update(Graphics g){
        paint(g);
    }
    public void paint(Graphics f){
        bufferImage=createImage(getSize().width,getSize().height);
        bufferGraphics=bufferImage.getGraphics();
        g = jPanel1.getGraphics();
        g.clipRect(0,0, 237,237);
        g2 = (Graphics2D)bufferGraphics;

        bufferGraphics.drawImage(speedpic,0,0,this);

        g2.translate(119,119);
        g2.rotate(Math.toRadians(speed2radiant));
        g2.drawImage(mach,-119,-119,this);
        g2.rotate(Math.toRadians(-speed2radiant));
        g2.rotate(Math.toRadians(speed1radiant));
        g2.drawImage(speedarrow,-119,-119,this);
//        g2.drawImage(mach,0,0,this);
//        g2.drawImage(speedarrow,0,0,this);
        g.drawImage(bufferImage,0,0,this);

    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();

        setResizable(false);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                click(evt);
            }
        });

        jPanel1.setMinimumSize(new java.awt.Dimension(237, 237));
        jPanel1.setPreferredSize(new java.awt.Dimension(237, 237));
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void click(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_click
         jlockon.newspeed(this.isUndecorated(),this.getX(),this.getY());
        this.dispose();
    }//GEN-LAST:event_click
    
    /** Exit the Application */    

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
