/*
 * JLockOnVSI.java
 *
 * Created on 7. Juli 2004, 15:35
 */

package JLockOn;

/**
 *
 * @author  www.Flike.de
 *   Copyright 2004 Tobias Flaig
 *   JLockOn is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.awt.*;

public class JLockOnVSI extends javax.swing.JFrame {
    
    double velo=0.0;
    double vsi1radiant=270.0;
    Graphics g ;
    Graphics2D g2;
    Image vsi;
    Image vsiarrow;
    private Image bufferImage;
    private Graphics bufferGraphics;
    JLockOn jlockon;
    
    /** Creates new form JLockOnVSI */
    public JLockOnVSI(JLockOn ajlockon) {
        jlockon=ajlockon;
        initComponents();
        this.setLocation(238,0);
        try{
            java.net.URL imageURL =getClass().getResource("vvi.gif");
            vsi=getToolkit().createImage((java.awt.image.ImageProducer) imageURL.getContent());//f:/tobias/JLockOn/JLockOn/
            imageURL =getClass().getResource("altarrow.gif");
            vsiarrow=getToolkit().createImage((java.awt.image.ImageProducer) imageURL.getContent());
            
        } catch (Exception e){
            System.out.println(e);
        }
        super.repaint();
    }
    
    
    public void newData(double v){
        velo=v;
        if (velo>0 && velo<2500){
            velo=velo*1300.0/2500.0;
        } else if (velo>2500){
            velo=2600.0-(velo*1300.0/2500);
        } else if (velo>0 && velo<2500){
            velo=velo*1300.0/2500.0;
        } else if (velo>2500){
            velo=(2600.0-(velo*1300.0/2500))*-1.0;
        }
        
        vsi1radiant=270+(170.0/6000.0*velo);
//        System.out.println(velo+","+vsi1radiant);
        super.repaint();
    }
    
    public void update(Graphics g){
        paint(g);
    }
    public void paint(Graphics f){
        bufferImage=createImage(getSize().width,getSize().height);
        bufferGraphics=bufferImage.getGraphics();
        g = jPanel1.getGraphics();
        g.clipRect(0,0, 237,237);
        g2 = (Graphics2D)bufferGraphics; 

        bufferGraphics.drawImage(vsi,0,0,this);

        g2.translate(119,119);
        g2.rotate(Math.toRadians(vsi1radiant));
        g2.drawImage(vsiarrow,-119,-119,this);
        g.drawImage(bufferImage,0,0,this);

    }
    
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();

        setResizable(false);
        setUndecorated(true);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel1.setMinimumSize(new java.awt.Dimension(237, 237));
        jPanel1.setPreferredSize(new java.awt.Dimension(237, 237));
        jPanel1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                move(evt);
            }
        });

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void move(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_move
        this.setLocation(evt.getX(), evt.getY());
    }//GEN-LAST:event_move
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
