/*
 * JLockOn.java
 *
 * Created on 27. Juni 2004, 19:02
 */

package JLockOn;



/**
 *
 * @author  www.Flike.de
 *   Copyright 2004 Tobias Flaig
 *   JLockOn is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//import java.awt.*;
//import java.awt.event.*;

public class JLockOn extends javax.swing.JFrame {
    
    JLockOnListener jlockonlistener=null;
    JLockOnAltitude jaltitude=null;
    JLockOnVVI jvvi=null;
    JLockOnSpeed jspeed=null;
    JLockOnAttitude jattitude=null;
    JLockOnAcceleration jacceleration=null;
    public int height1=0;
    public double velo=0.0;
    public double speed=0.0;
    public double pitch=0.0;
    public double bank=0.0;
    public double gforce=0.0;

    /** Creates new form JLockOn */
    public JLockOn() {
        initComponents();
        this.setLocation(474,0);
        jlockonlistener = new JLockOnListener(this);
        jaltitude=new JLockOnAltitude(this);
        jaltitude.setUndecorated(true);
        jaltitude.start(3,23);
        jaltitude.show();
        jvvi=new JLockOnVVI(this);
        jvvi.setUndecorated(true);
        jvvi.start(240,23);
        jvvi.show();
        jspeed=new JLockOnSpeed(this);
        jspeed.setUndecorated(true);
        jspeed.start(3,260);
        jspeed.setA10(A10.isSelected());
        jspeed.show();
        jattitude=new JLockOnAttitude(this);
        jattitude.setUndecorated(true);
        jattitude.start(240,260);
        jattitude.show();
        jacceleration=new JLockOnAcceleration(this);
        jacceleration.setUndecorated(true);
        jacceleration.start(3,497);
        jacceleration.show();
        repaint();
        super.repaint();
    }
    
    public void newattitude(boolean b,int x, int y){
        jattitude=new JLockOnAttitude(this);
        jattitude.setUndecorated(!b);
        if (b){
            jattitude.start(x-3,y-23);
        } else {
            jattitude.start(x+3,y+23);
        }
        jattitude.show();
        
    }
    public void newacceleration(boolean b,int x, int y){
        jacceleration=new JLockOnAcceleration(this);
        jacceleration.setUndecorated(!b);
        if (b){
            jacceleration.start(x-3,y-23);
        } else {
            jacceleration.start(x+3,y+23);
        }
        jacceleration.show();
        
    }
    
    public void newspeed(boolean b,int x, int y){
        jspeed=new JLockOnSpeed(this);
        jspeed.setUndecorated(!b);
        if (b){
            jspeed.start(x-3,y-23);
        } else {
            jspeed.start(x+3,y+23);
        }
        jspeed.setA10(A10.isSelected());
        jspeed.show();
        
    }
    public void newvvi(boolean b,int x, int y){
        jvvi=new JLockOnVVI(this);
        jvvi.setUndecorated(!b);
        if (b){
            jvvi.start(x-3,y-23);
        } else {
            jvvi.start(x+3,y+23);
        }
        jvvi.show();
        
    }
    public void newaltitude(boolean b,int x, int y){
        jaltitude=new JLockOnAltitude(this);
        jaltitude.setUndecorated(!b);
        if (b){
            jaltitude.start(x-3,y-23);
        } else {
            jaltitude.start(x+3,y+23);
        }
        jaltitude.show();
        
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        ChBoxAlt = new javax.swing.JCheckBox();
        F15 = new javax.swing.JRadioButton();
        ChBoxVVI = new javax.swing.JCheckBox();
        A10 = new javax.swing.JRadioButton();
        ChBoxSpeed = new javax.swing.JCheckBox();
        SU27 = new javax.swing.JRadioButton();
        ChBoxAttitude = new javax.swing.JCheckBox();
        SU33 = new javax.swing.JRadioButton();
        ChBoxAcceleration = new javax.swing.JCheckBox();
        MIG29 = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        SU25 = new javax.swing.JRadioButton();

        setTitle("JLockOn by Flike");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel1.setLayout(new java.awt.GridLayout(6, 2));

        jPanel1.setMinimumSize(new java.awt.Dimension(237, 237));
        jPanel1.setPreferredSize(new java.awt.Dimension(237, 237));
        ChBoxAlt.setSelected(true);
        ChBoxAlt.setText("Altimeter");
        ChBoxAlt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ChBoxAltActionPerformed(evt);
            }
        });

        jPanel1.add(ChBoxAlt);

        F15.setSelected(true);
        F15.setText("F-15");
        F15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                F15ActionPerformed(evt);
            }
        });

        jPanel1.add(F15);

        ChBoxVVI.setSelected(true);
        ChBoxVVI.setText("VerticalVelocityIndicator");
        ChBoxVVI.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ChBoxVVIActionPerformed(evt);
            }
        });

        jPanel1.add(ChBoxVVI);

        A10.setText("A-10");
        A10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                A10ActionPerformed(evt);
            }
        });

        jPanel1.add(A10);

        ChBoxSpeed.setSelected(true);
        ChBoxSpeed.setText("SpeedIncicator");
        ChBoxSpeed.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ChBoxSpeedActionPerformed(evt);
            }
        });

        jPanel1.add(ChBoxSpeed);

        SU27.setText("SU-27");
        SU27.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SU27ActionPerformed(evt);
            }
        });

        jPanel1.add(SU27);

        ChBoxAttitude.setSelected(true);
        ChBoxAttitude.setText("AttitudeDirectorIndicator");
        ChBoxAttitude.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ChBoxAttitudeActionPerformed(evt);
            }
        });

        jPanel1.add(ChBoxAttitude);

        SU33.setText("SU-33");
        SU33.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SU33ActionPerformed(evt);
            }
        });

        jPanel1.add(SU33);

        ChBoxAcceleration.setSelected(true);
        ChBoxAcceleration.setText("Accelerometer");
        ChBoxAcceleration.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ChBoxAccelerationActionPerformed(evt);
            }
        });

        jPanel1.add(ChBoxAcceleration);

        MIG29.setText("MIG 29 A");
        MIG29.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MIG29ActionPerformed(evt);
            }
        });

        jPanel1.add(MIG29);

        jPanel1.add(jLabel1);

        SU25.setText("SU-25");
        SU25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SU25ActionPerformed(evt);
            }
        });

        jPanel1.add(SU25);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void SU25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SU25ActionPerformed
        F15.setSelected(false);
        A10.setSelected(false);
        SU27.setSelected(false);
        SU33.setSelected(false);
        MIG29.setSelected(false);
        SU25.setSelected(true);
        
        jspeed.setA10(A10.isSelected());
        jattitude.setRus(SU27.isSelected() || SU33.isSelected() || MIG29.isSelected() || SU25.isSelected());
    }//GEN-LAST:event_SU25ActionPerformed

    private void MIG29ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MIG29ActionPerformed
        F15.setSelected(false);
        A10.setSelected(false);
        SU27.setSelected(false);
        SU33.setSelected(false);
        MIG29.setSelected(true);
        SU25.setSelected(false);
        
        jspeed.setA10(A10.isSelected());
        jattitude.setRus(SU27.isSelected() || SU33.isSelected() || MIG29.isSelected() || SU25.isSelected());
    }//GEN-LAST:event_MIG29ActionPerformed

    private void SU33ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SU33ActionPerformed
        F15.setSelected(false);
        A10.setSelected(false);
        SU27.setSelected(false);
        SU33.setSelected(true);
        MIG29.setSelected(false);
        SU25.setSelected(false);
        
        jspeed.setA10(A10.isSelected());
        jattitude.setRus(SU27.isSelected() || SU33.isSelected() || MIG29.isSelected() || SU25.isSelected());
    }//GEN-LAST:event_SU33ActionPerformed

    private void SU27ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SU27ActionPerformed
        F15.setSelected(false);
        A10.setSelected(false);
        SU27.setSelected(true);
        SU33.setSelected(false);
        MIG29.setSelected(false);
        SU25.setSelected(false);
        
        jspeed.setA10(A10.isSelected());
        jattitude.setRus(SU27.isSelected() || SU33.isSelected() || MIG29.isSelected() || SU25.isSelected());
    }//GEN-LAST:event_SU27ActionPerformed

    private void A10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_A10ActionPerformed
        F15.setSelected(false);
        A10.setSelected(true);
        SU27.setSelected(false);
        SU33.setSelected(false);
        MIG29.setSelected(false);
        SU25.setSelected(false);
        
        jspeed.setA10(A10.isSelected());
        jattitude.setRus(SU27.isSelected() || SU33.isSelected() || MIG29.isSelected() || SU25.isSelected());
    }//GEN-LAST:event_A10ActionPerformed

    private void F15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_F15ActionPerformed
        F15.setSelected(true);
        A10.setSelected(false);
        SU27.setSelected(false);
        SU33.setSelected(false);
        MIG29.setSelected(false);
        SU25.setSelected(false);
        
        jspeed.setA10(A10.isSelected());
        jattitude.setRus(SU27.isSelected() || SU33.isSelected() || MIG29.isSelected() || SU25.isSelected());
    }//GEN-LAST:event_F15ActionPerformed

    private void ChBoxAccelerationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ChBoxAccelerationActionPerformed
         if (ChBoxAcceleration.isSelected()){
            jacceleration.show();
        } else {
            jacceleration.hide();
        }
    }//GEN-LAST:event_ChBoxAccelerationActionPerformed

    private void ChBoxAttitudeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ChBoxAttitudeActionPerformed
        if (ChBoxAttitude.isSelected()){
            jattitude.show();
        } else {
            jattitude.hide();
        }
    }//GEN-LAST:event_ChBoxAttitudeActionPerformed

    private void ChBoxSpeedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ChBoxSpeedActionPerformed
        if (ChBoxSpeed.isSelected()){
            jspeed.show();
        } else {
            jspeed.hide();
        }
    }//GEN-LAST:event_ChBoxSpeedActionPerformed

    private void ChBoxVVIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ChBoxVVIActionPerformed
        if (ChBoxVVI.isSelected()){
            jvvi.show();
        } else {
            jvvi.hide();
        }
    }//GEN-LAST:event_ChBoxVVIActionPerformed

    private void ChBoxAltActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ChBoxAltActionPerformed
        if (ChBoxAlt.isSelected()){
            jaltitude.show();
        } else {
            jaltitude.hide();
        }
    }//GEN-LAST:event_ChBoxAltActionPerformed
    
    public void newData(){
        jaltitude.newData(height1);
        jvvi.newData(velo);
        jspeed.newData(speed);
        jattitude.newData(pitch,bank);
        jacceleration.newData(gforce);
    }

    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new JLockOn().show();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton A10;
    private javax.swing.JCheckBox ChBoxAcceleration;
    private javax.swing.JCheckBox ChBoxAlt;
    private javax.swing.JCheckBox ChBoxAttitude;
    private javax.swing.JCheckBox ChBoxSpeed;
    private javax.swing.JCheckBox ChBoxVVI;
    private javax.swing.JRadioButton F15;
    private javax.swing.JRadioButton MIG29;
    private javax.swing.JRadioButton SU25;
    private javax.swing.JRadioButton SU27;
    private javax.swing.JRadioButton SU33;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
